var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as classnames from "classnames";
import * as React from "react";
import * as PropTypes from "prop-types";
import Col from "./Col";
import MorePropTypes from "../utils/MorePropTypes";
import Row from "./Row";
import Size from "./Size";
import "../less/grid.less";
export var cssClass = {
    GRID: "Grid",
};
export var Grid = function Grid(_a) {
    var className = _a.className, children = _a.children, Wrapper = _a.wrapperComponent, additionalProps = __rest(_a, ["className", "children", "wrapperComponent"]);
    return (React.createElement(Wrapper, __assign({ className: classnames(cssClass.GRID, className) }, additionalProps), children));
};
Grid.Row = Row;
Grid.Col = Col;
Grid.Size = Size;
Grid.propTypes = {
    children: MorePropTypes.oneOrManyOf(MorePropTypes.instanceOfComponent(Row)),
    className: PropTypes.string,
    wrapperComponent: PropTypes.any,
};
Grid.defaultProps = {
    wrapperComponent: "div",
};
